/***********************************************************************************************************************
 *
 * blueBill Mobile - Android - open source birding
 * Copyright (C) 2009-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://bluebill.tidalwave.it/mobile
 * SCM: https://kenai.com/hg/bluebill~android-src
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.mobile.role.util;

import it.tidalwave.netbeans.capabilitiesprovider.CapabilitiesProvider;
import java.util.Collection;
import java.util.Collections;
import javax.annotation.Nonnull;
import lombok.Getter;
import lombok.RequiredArgsConstructor;
import org.openide.util.Lookup;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
@RequiredArgsConstructor
public class RolesCapabilitiesProvider<T> implements CapabilitiesProvider<T>
  {    
    @Nonnull @Getter
    private final Class<T> managedClass;
    
    @Nonnull 
    private final Collection<Object> roles;
    
    @Nonnull
    public Collection<? extends Object> createCapabilities (final @Nonnull Object owner) 
      {
        return roles;
      }

    @Nonnull
    public Collection<? extends Lookup> createLookups (final @Nonnull Object owner) 
      {
        return Collections.<Lookup>emptyList();
      }                    
  } 
